class TasksController < ApplicationController
  # GET /tasks
  # GET /tasks.xml
  def index
    @tasks = Hash.new
    @tasks["ToDo"] = Task.find(:all, :conditions=>["status=?", "ToDo"], :order=>"priority desc")
    @tasks["Doing"] = Task.find(:all, :conditions=>["status=?", "Doing"], :order=>"priority desc")
    @tasks["Done"] = Task.find(:all, :conditions=>["status=?", "Done"], :order=>"updated_at desc")

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @tasks }
    end
  end

  # GET /tasks/1
  # GET /tasks/1.xml
  def show
    @task = Task.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @task }
    end
  end

  # GET /tasks/new
  # GET /tasks/new.xml
  def new
    @task = Task.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @task }
    end
  end

  # GET /tasks/1/edit
  def edit
    @task = Task.find(params[:id])
  end

  # POST /tasks
  # POST /tasks.xml
  def create
    @task = Task.new(params[:task])

    respond_to do |format|
      if @task.save
        format.html { redirect_to(:action=>:index) }
        format.xml  { render :xml => @task, :status => :created, :location => @task }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @task.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /tasks/1
  # PUT /tasks/1.xml
  def update
    @task = Task.find(params[:id])

    respond_to do |format|
      if @task.update_attributes(params[:task])
        format.html { redirect_to(:action=>:index) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @task.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.xml
  def destroy
    @task = Task.find(params[:id])
    @task.destroy
    logger.debug("how do you do ?  ")
    logger.flush
    render :update do |page|
      page.visual_effect :fade, "#{params[:id]}", :duration=>0.6
    end
  end

  # PUT /tasks/change_status
  # PUT /tasks/1.xml
  def change_status
    @task = Task.find(params[:id])
    if @task.update_attributes(:status=>params[:status])
      render :update do |page|
        page.visual_effect :highlight, "#{params[:id]}", :duration=>0.6
      end
    end
  end
end
