class UsersController < ApplicationController
  # GET /users
  # GET /users.xml
  def index
    @users = User.all

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @users }
    end
  end

  # GET /users/new
  # GET /users/new.xml
  def new
    @user = User.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @user }
    end
  end

  # GET /users/1/edit
  def edit
    @user = User.find(params[:id])
  end

  # POST /users
  # POST /users.xml
  def create
    @user = User.new(params[:user])

    respond_to do |format|
      if @user.save
        format.html { redirect_to(:action=>:index) } 
        format.xml  { render :xml => @user, :status => :created, :location => @user }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @user.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /users/1
  # PUT /users/1.xml
  def update
    @user = User.find(params[:id])

    respond_to do |format|
      if @user.update_attributes(params[:user])
        format.html { redirect_to(:action=>:index) } 
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @user.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.xml
  def destroy
    @user = User.find(params[:id])
    @user.destroy

    respond_to do |format|
      format.html { redirect_to(users_url) }
      format.xml  { head :ok }
    end
  end
  
  def login #ログイン
    if request.post? #ポストの場合は認証、getはログイン画面へ
      user = User.auth(params[:name], params[:password])
      if user #認証OKかどうか
        session[:user] = user.name #セッションへユーザーIDを格納
        redirect_to(:controller=>:tasks, :action=>"index") #タスク一覧へ戻る
      else #認証失敗はメッセージ表示
        flash.now[:notice] = "無効なユーザ/パスワードの組合せです"
      end
    end
  end

  def logout #ログアウト
    session[:user] = nil #セッションからユーザーIDを削除
    flash[:notice] = "ログアウトしました"
    redirect_to(:controller=>:tasks,:action=>"index")  #タスク一覧へ戻る
  end

end
