require 'digest/sha1' #暗号化のためのライブラリをrequireする

class User < ActiveRecord::Base
  validates_presence_of :name, :password
  validates_uniqueness_of :name
  attr_accessor :password_confirmation, :password
  validates_confirmation_of :password

  def password=(pwd) #パスワードのセッターを再定義する
	@password = pwd
return if pwd.blank? #パスワードが空欄じゃなければ
self.hashed_password = User.encrypt(@password)  #暗号化してhashed_passwordに保存
  end

  def self.auth(name, pwd) #認証メソッド、ユーザーID、パスワードで認証する、クラスメソッドとして定義する
	user = self.find_by_name(name)
	user = nil if user.hashed_password != encrypt(pwd) #暗号化したものと比較して不一致だったらuserにnilをセット、一致していたらそのままUserを返す。
	user
  end

private
  def self.encrypt pwd #暗号化するprivateメソッドを定義
	Digest::SHA1.hexdigest(pwd + "ruby") #パスワードの文字列に固定文字列を加えてSHA1で暗号化したものを返す。
  end
end
