require 'test_helper'

class UsersControllerTest < ActionController::TestCase
  test "should get index" do
    get :index
    assert_response :success
    assert_not_nil assigns(:users)
  end

  test "should get new" do
    get :new
    assert_response :success
  end

  test "should create user" do
    assert_difference('User.count') do
      post :create, :user => {:name=>"Tanaka", :password=>"pass", :password_confirmation=>"pass" }
    end

    assert_redirected_to users_path
    #assert_redirected_to user_path(assigns(:user))
  end

  test "should get show raise TemplateError" do
    assert_raise ActionView::TemplateError do
      get :show, :id => users(:one).to_param
    end
  end

  test "should get edit" do
    get :edit, :id => users(:one).to_param
    assert_response :success
  end

  test "should update user" do
    put :update, :id => users(:one).to_param, :user => {:password=>"poss", :password_confirmation=>"poss" }
    assert_redirected_to users_path
#    assert_redirected_to user_path(assigns(:user))
  end

  test "should destroy user" do
    assert_difference('User.count', -1) do
      delete :destroy, :id => users(:one).to_param
    end

    assert_redirected_to users_path
  end
  
  test "should get login" do
    get :login
    assert_response :success
    
    assert_select "form input", 3
    assert_select "form", true
    assert_select "form input[name=name]", true
    
    assert_select "form[action=/users/login]" do
      assert_select "input[name=name]"
      assert_select "input[name=password]"
    end
  end
  
  test "should login success" do
    User.create(:name => "tanaka", :password=>"pass", :password_confirmation=>"pass")
    post :login, :name=>"Tanaka", :password=>"pass", :password_confirmation=>"pass" 
    assert_redirected_to tasks_path
  end
  
  test "should login failed" do
    post :login, :name=>"Ono", :password=>"bass", :password_confirmation=>"bass" 
    assert_response :success
    assert_equal "無効なユーザ/パスワードの組合せです", flash[:notice]
  end
  
  test "should logout" do
    put :logout
    assert_redirected_to tasks_path
  end
end
