

require 'test_helper'

class KanbanFlowTest < ActionController::IntegrationTest
  fixtures :all

  test "login and task flow" do
	Task.delete_all
	assert_equal(1, User.find(:all).size)

	post_via_redirect "/users/create",
	  :user => {
		:name => "Tanaka", 
		:password => "pass", 
		:password_confirmation => "pass"}
	assert_response :success
	assert_equal '/users', path
	assert_equal(2, User.find(:all).size)

	get "/tasks"
	assert_response :success
	assert_template "index"

	get "/users/login"
	assert_response :success
	assert_template "login"

	post_via_redirect "/users/login", 
	  :name => "Tanaka", 
	  :password => "pass"
	assert_response :success
	assert_equal '/tasks', path
	assert_equal "Tanaka", session[:user]

	assert_equal(0, Task.find(:all).size)
	post_via_redirect "/tasks/create",
	  :task => {
		:content => "ToDo Task",
		:status =>  "ToDo",
		:priority => 1,
		:owner => "Tanaka"}
	post_via_redirect "/tasks/create",
	  :task => {
		:content => "Doing Task",
		:status =>  "ToDo",
		:priority => 2,
		:owner => "Tanaka"}
	post_via_redirect "/tasks/create",
	  :task => {
		:content => "Done Task",
		:status =>  "ToDo",
		:priority => 3,
		:owner => "Tanaka"}
	assert_equal(3, Task.find(:all).size)

	tasks = Task.find(:all, :conditions => ["content = ? ", "Doing Task"] )
	assert_equal(1, tasks.size)

	post "/tasks/change_status",
	  :id => tasks[0].id,
	  :status => "Doing"
	assert_response :success
	assert_equal(1, Task.find(:all, :conditions => ["status = ? ", "Doing"] ).size)

	tasks = Task.find(:all, :conditions => ["content = ? ", "Done Task"] )
	assert_equal(1, tasks.size)

	post "/tasks/change_status",
	  :id => tasks[0].id,
	  :status => "Done"
	assert_response :success

	get "/tasks"
	tasks = assigns(:tasks)
	assert_equal 3, tasks.size

	assert_equal(1, tasks["ToDo"].size) #Task.find(:all, :conditions => ["status = ? ", "ToDo"] ).count)
	assert_equal(1, tasks["Doing"].size) #Task.find(:all, :conditions => ["status = ? ", "Doing"] ).count)
	assert_equal(1, tasks["Done"].size) #Task.find(:all, :conditions => ["status = ? ", "Done"] ).count)

	post_via_redirect "/users/logout"
	assert_response :success
	assert_equal 'ログアウトしました', flash[:notice]


	#https!
	#https!(false)
	#get "/posts/all"
	#assert_response :success
	#assert assigns(:products)
  end
end
