require 'test_helper'

class UserTest < ActiveSupport::TestCase
  test "valid user test" do  
    user = User.new(:name => "tanaka", :password=>"pass", :password_confirmation=>"pass")
    assert user.valid?
  end  
  
  test "empty attributes" do
    user = User.new
    assert !user.valid?
    assert user.errors.invalid?(:name)
    assert user.errors.invalid?(:password)
  end
    
  test "password not match" do
    user = User.new(:name => "tanaka", :password=>"pass", :password_confirmation=>"pazz")
    assert !user.valid?
  end
  
  test "duplicate name" do
    user = User.new(:name => "ono", :password=>"pass", :password_confirmation=>"pass")
    assert !user.valid?
  end

  test "user auth test" do  
    user = User.new(:name => "tanaka", :password=>"pass", :password_confirmation=>"pass")
    user.save
    assert User.auth("tanaka", "pass")
  end
end
